"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const nunjucks = require('nunjucks');
const fs_1 = require('fs');
function engine(app) {
    return function render(ctx, next) {
        return __awaiter(this, void 0, void 0, function* () {
            ctx.render = function (data) {
                return __awaiter(this, void 0, void 0, function* () {
                    const filename = `${ctx.controller.name}/${ctx.controller.action}.html`;
                    const controllerApp = app.apps.get(ctx.controller.app);
                    const renderCtx = app.createRenderContext(ctx.controller.app, data);
                    data = Object.assign({}, data);
                    const paths = [
                        controllerApp.views,
                        `${app.settings.views}/${ctx.controller.app}`,
                        app.settings.views,
                    ];
                    const candidates = yield Promise.all(paths.map(viewDir => {
                        return new Promise((resolve, reject) => {
                            const test = `${viewDir}/${filename}`;
                            fs_1.stat(test, (err, res) => {
                                if (err)
                                    resolve(false);
                                resolve(true);
                            });
                        });
                    }));
                    const base = paths[candidates.findIndex(p => p === true)];
                    const env = nunjucks.configure(paths, { watch: true });
                    const renderEnv = app.settings.nunjucksEnv ? Object.assign(app.settings.nunjucksEnv, { loaders: env.loaders, opts: env.opts }) : env;
                    renderEnv.addGlobal('css', ctx.state.css);
                    renderEnv.addGlobal('js', ctx.state.js);
                    renderEnv.addGlobal('asset_path', ctx.state.asset_path);
                    return yield renderEnv.render(base + '/' + filename, renderCtx);
                });
            };
            yield next();
        });
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = engine;
